######################################################################
##
## Copyright (C) 2006,  Blekinge Institute of Technology
##
## Filename:      File.py
## Author:        Simon Kagstrom <ska@bth.se>
## Description:   Describes one file
##
## $Id: File.py 8336 2006-05-26 18:47:58Z ska $
##
######################################################################
from Function import *
from Instruction import *
from Entity import Entity

class File(Entity):
    def __init__(self, arch=None):
	self.functions = []
	self.arch = arch

    def lookup_int(self, address):
	for fn in self.functions:
	    extents = fn.getExtents()
	    if address >= extents[0] and address <= extents[1]:
		return fn
	return None

    def lookup_str(self, label):
	for fn in self.functions:
	    if label == fn.getLabel():
		return fn
	return None

    def lookup(self, param):
	if isinstance(param, long):
	    return self.lookup_int(param)
	return self.lookup_str(param)

    def getArch(self):
	return self.arch

    def addFunction(self, fn):
	self.functions.append(fn)

    def link(self):
	for fn in self.functions:
	    unresolved = fn.link()
	    for insn in unresolved:
		other = self.lookup(insn.getAddress())
		if other:
		    insn.linkTo(other)

    def getFunctions(self):
	return self.functions
