######################################################################
##
## Copyright (C) 2006,  Blekinge Institute of Technology
##
## Filename:      PreferencesDialogue.py
## Author:        Simon Kagstrom <ska@bth.se>
## Description:   Preferences dialog
##
## $Id: PreferencesDialogue.py 8336 2006-05-26 18:47:58Z ska $
##
######################################################################
import pygtk

pygtk.require('2.0')
import gtk, gobject

from Config import *

class PreferencesDialogue:
    def __init__(self, w=None):
	dialog = gtk.Dialog("%s - Preferences" % (PROGRAM_NAME))
	defaults = gtk.Button("Defaults")
	cancel = gtk.Button("Cancel", gtk.STOCK_CANCEL)
	ok = gtk.Button("OK", gtk.STOCK_OK)

	table = gtk.Table(3, 2, False)
	objdump = gtk.Entry()
	readelf = gtk.Entry()
	showHighLevel = gtk.CheckButton("Show high level code")

	cancel.connect("clicked", lambda w: dialog.destroy())
	ok.connect("clicked", self.okSelected,
		   dialog, objdump, readelf, showHighLevel)
	defaults.connect("clicked", self.defaultsSelected,
			 objdump, readelf, showHighLevel)

	objdump.set_text(config.objdumpCommand)
	objdump.set_width_chars(max(30,len(config.objdumpCommand)))
	readelf.set_text(config.readelfCommand)
	showHighLevel.set_active(config.showHighLevelCode)

	table.attach(gtk.Label("Objdump:"), 0, 1, 0, 1,  ypadding=2)
	table.attach(gtk.Label("Readelf:"), 0, 1, 1, 2,  ypadding=2)
	table.attach(readelf, 1, 2, 1, 2,  ypadding=2)
	table.attach(objdump, 1, 2, 0, 1,  ypadding=2)
	table.attach(showHighLevel, 0, 2, 2, 3,  ypadding=6)

	dialog.vbox.pack_start(table, True, True, 0)
	dialog.action_area.pack_start(defaults, True, True, 0)
	dialog.action_area.pack_start(cancel, True, True, 0)
	dialog.action_area.pack_start(ok, True, True, 0)
	dialog.show_all()

    def defaultsSelected(self, widget, objdump, readelf, showHighLevel):
	config.restoreAllDefaults()
	objdump.set_text(config.objdumpCommand)
	objdump.set_width_chars(max(30,len(config.objdumpCommand)))
	readelf.set_text(config.readelfCommand)
	showHighLevel.set_active(config.showHighLevelCode)

    def okSelected(self, widget, dialog, objdump, readelf, showHighLevelCode):
	if objdump.get_text() == "":
	    config.objdumpCommand = config.getDefault("objdumpCommand")
	else:
	    config.objdumpCommand = objdump.get_text()

	if readelf.get_text() == "":
	    config.readelfCommand = config.getDefault("readelfCommand")
	else:
	    config.readelfCommand = readelf.get_text()

	config.showHighLevelCode = showHighLevelCode.get_active()
	config.save()

	dialog.destroy()
