######################################################################
##
## Copyright (C) 2006,  Blekinge Institute of Technology
##
## Filename:      architecture.py
## Author:        Simon Kagstrom <ska@bth.se>
## Description:   Base-class for architecture handling
##
## $Id: architecture.py 8337 2006-05-26 20:00:53Z ska $
##
######################################################################
class Architecture:
    def __init__(self, arch_jumps):
	self.jumps = {}
	for s in arch_jumps:
	    self.jumps[s.strip()] = 1

    def isJump(self, insn):
	return insn in self.jumps

    def getJumpDestination(self, insn, args):
	try:
	    return long(args, 16)
	except ValueError:
	    pass
	return None

from dissy import mips, intel

def getArchitecture(archStr):
    if archStr == "intel":
	return intel.IntelArchitecture()
    if archStr == "mips":
	return mips.MipsArchitecture()
    return Architecture()
